#ifndef STORE_DECL_INC
#define STORE_DECL_INC
//#pragma pack(8)


//#define SOLFS_MAX_STORAGE_SIZE 2048 

//$ifdef 0

//#if !defined(SOLFS_NO_CUSTOM) && !defined(SOLFS_CUSTOM_ALFEGA) && !defined(SOLFS_CUSTOM_LX)
//#define SOLFS_NO_CUSTOM
//#endif

#ifndef SOLFS_NO_CUSTOM
#define SOLFS_NO_TRIAL
#endif // SOLFS_NT_DRV_API

//$endif

#ifndef __BORLANDC__
#ifdef __GNUC__
#ifdef __INTERIX
#include "sys/endian.inc"
#else
#include "endian.inc"
#endif
# endif
#define SOLFS_LITTLE_ENDIAN   1234 /* byte 0 is least significant (i386) */
#define SOLFS_BIG_ENDIAN      4321 /* byte 0 is most significant (mc68k) */
#if !defined(SOLFS_BYTE_ORDER)
#if defined(LITTLE_ENDIAN) || defined(BIG_ENDIAN)
#  if defined(LITTLE_ENDIAN) && defined(BIG_ENDIAN)
#    if defined(BYTE_ORDER)
#      if   (BYTE_ORDER == LITTLE_ENDIAN)
#        define SOLFS_BYTE_ORDER SOLFS_LITTLE_ENDIAN
#      elif (BYTE_ORDER == BIG_ENDIAN)
#        define SOLFS_BYTE_ORDER SOLFS_BIG_ENDIAN
#      endif
#    endif
#  elif defined(LITTLE_ENDIAN) && !defined(BIG_ENDIAN)
#    define SOLFS_BYTE_ORDER SOLFS_LITTLE_ENDIAN
#  elif !defined(LITTLE_ENDIAN) && defined(BIG_ENDIAN)
#    define SOLFS_BYTE_ORDER SOLFS_BIG_ENDIAN
#  endif
#elif defined(_LITTLE_ENDIAN) || defined(_BIG_ENDIAN)
#  if defined(_LITTLE_ENDIAN) && defined(_BIG_ENDIAN)
#    if defined(_BYTE_ORDER)
#      if   (_BYTE_ORDER == _LITTLE_ENDIAN)
#        define SOLFS_BYTE_ORDER SOLFS_LITTLE_ENDIAN
#      elif (_BYTE_ORDER == _BIG_ENDIAN)
#        define SOLFS_BYTE_ORDER SOLFS_BIG_ENDIAN
#      endif
#    endif
#  elif defined(_LITTLE_ENDIAN) && !defined(_BIG_ENDIAN)
#    define SOLFS_BYTE_ORDER SOLFS_LITTLE_ENDIAN
#  elif !defined(_LITTLE_ENDIAN) && defined(_BIG_ENDIAN)
#    define SOLFS_BYTE_ORDER SOLFS_BIG_ENDIAN
#  endif
#elif 0     /* **** EDIT HERE IF NECESSARY **** */
#define SOLFS_BYTE_ORDER SOLFS_LITTLE_ENDIAN
#elif 0     /* **** EDIT HERE IF NECESSARY **** */
#define SOLFS_BYTE_ORDER SOLFS_BIG_ENDIAN
#elif (('1234' >> 24) == '1')
#  define SOLFS_BYTE_ORDER SOLFS_LITTLE_ENDIAN
#elif (('4321' >> 24) == '1')
#  define SOLFS_BYTE_ORDER SOLFS_BIG_ENDIAN
#endif
#endif
#else
#  define SOLFS_BYTE_ORDER SOLFS_LITTLE_ENDIAN
#endif //__BORLANDC__

//#if (defined(WIN32) || defined (_WIN32) || defined (x64)) && !defined(_WINDOWS) && !defined(SOLFS_NT_DRV)
#define _WINDOWS
//#endif // _WINDOWS

#ifdef _UNICODE//)) && (!defined(UNICODE))
#define UNICODE
#endif

#ifdef SOLFS_NT_DRV
#define SOLFS_WINDOWS
//#pragma warning(disable: 4390)
#ifdef _WIN64
#define SOLFS_64BIT
#endif
#define SOLFS_WIN32
#define SOLFS_NO_FPU
#define SOLFS_ASSERT
#define SOLFS_ASSERT_REWRITE
#endif // SOLFS_NT_DRV

#ifdef SOLFS_NT_DRV_API
#define SOLFS_NO_TRIAL
#endif // SOLFS_NT_DRV_API

#ifdef _WINDOWS
#define SOLFS_WINDOWS
#include "windows.inc"
#include "winnt.inc"
#include "stdlib.inc"
#ifdef _WIN64
#define SOLFS_64BIT
#endif
#ifdef _WIN32_WCE
//#define SOLFS_WINCE
//#elif defined(_MANAGED)
//#define SOLFS_DOTNET
//#pragma warning(disable:4996)
//#define _CRT_SECURE_NO_DEPRECATE
#else
#define SOLFS_WIN32
#endif // _WIN32_WCE
#ifdef B6_UP
#include "algorith.inc"
#endif // B6_UP
#ifdef __BORLANDC__
//#pragma warn -aus
#endif // __BCPLUSPLUS__
#endif // _WINDOWS

#ifdef __GNUC__
#define SOLFS_UNIX
//#include "assert.inc"
#ifdef __INTERIX
#define _ALL_SOURCE
#define _REENTRANT
#endif // __INTERIX
#include "features.inc"
#ifndef __USE_UNIX98
#define __USE_UNIX98
#endif // __USE_UNIX98
#include "unistd.inc"
#include "sys\\types.inc"
#include "sys\\stat.inc"
#include "sys\\time.inc"
#include "fcntl.inc"
#include "limits.inc"
#include "stdlib.inc"
#include "errno.inc"
#include "wchar.inc"
#include "iconv.inc"
#include "pthread.inc"
#include "string.inc"
#ifndef __INTERIX
#include "asm\\atomic.inc"
#include "stdint.inc"
#define _stdcall
#endif // __INTERIX
#ifdef __INTERIX
//#define _stdcall __stdcall
#endif // __INTERIX
//#define max(a, b) (((a)>(b))?(a):(b))
//#define min(a, b) (((a)<(b))?(a):(b))
#endif // __GNUC__

//#if defined(__MWERKS__) && defined(__MC68K__)
//#define SOLFS_PALM
//#undef SOLFS_BYTE_ORDER
//#define SOLFS_BYTE_ORDER SOLFS_BIG_ENDIAN
//#elif defined(__palmos__)
//#define SOLFS_PALM
//#undef SOLFS_BYTE_ORDER
//#define SOLFS_BYTE_ORDER SOLFS_BIG_ENDIAN
//#else
//#undef SOLFS_PALM
//#endif

#ifdef SOLFS_PALM
#include "PalmOS.inc"
#include "PalmTypes.inc"
#include "PalmCompatibility.inc"
#include "FileStream.inc"
//#pragma warn_unusedarg off
//#pragma warn_unusedvar off
//#define _stdcall
#endif // SOLFS_PALM

#ifndef SOLFS_BYTE_ORDER
#emit %error byte order could not be determined
#endif

/*# if (defined(_DEBUG) || defined(DEBUG))
#define SOLFS_ASSERT
#define SOLFS_DEBUG
# endif // _DEBUG*/

/*
# ifdef SOLFS_ASSERT
# if defined(SOLFS_NT_DRV)
#       define assert(t) ASSERT(t)
#       if DBG 
#           ifdef RELEASE_BUILD
#               undef assert
#               define assert( exp ) \
                    ((!(exp)) ? \
                    KeBugCheckEx(FILE_SYSTEM, 0 | __LINE__, 0, 0, 0 ) : \
                    TRUE)
#           endif //RELEASE_BUILD
#       endif //DBG
# elif defined(SOLFS_ASSERT_REWRITE)
# define assert(t) if (!(t)) StoreAssert(#t, __FILE__	, __LINE__)
# elif defined(SOLFS_WINCE)
# define assert(t)
# else
# include "assert.inc"
# endif
# endif // SOLFS_ASSERT
*/
#ifndef SOLFS_DLL_EXPORT
//#define DLLEXPORTSPEC
#else
//#define DLLEXPORTSPEC __declspec(dllexport)
#endif

/*
#ifdef _WIN32_WCE
#ifndef SOLFS_DLL_EXPORT
#ifdef _X86_
#define CALLCONVSPEC
#else
#define CALLCONVSPEC _stdcall
#endif
#else
#define CALLCONVSPEC _stdcall
#endif
#else
#define CALLCONVSPEC _stdcall
#endif
*/

#ifdef _WIN32_WCE
#ifndef SOLFS_DLL_EXPORT
#define CALLCONVSPEC
#else
//#define CALLCONVSPEC _stdcall
#endif
#ifndef _UNICODE
#define _UNICODE
#endif
#else
//#define CALLCONVSPEC _stdcall
#endif

#ifdef SOLFS_WINDOWS
#typedef char Byte;
//#typedef Word unsigned word
//typedef char Char;

#typedef LongLongWord unsigned int64
#typedef LongLongInt int64

//#typedef Handle pointer // void*
#typedef Error long

#ifndef SOLFS_DOTNET
#ifndef _WCHAR_T_DEFINED
#typedef WideChar unsigned word
#typedef PWideChar pointer // unsigned word *
#else
#typedef WideChar wchar_t
#typedef PWideChar pointer // wchar_t *
#endif
#else
#typedef WideChar wchar_t
#typedef PWideChar pointer // wchar_t*
#endif

#typedef TSeekOrigin unsigned word
#define soFromBegin 0
#define soFromCurrent 1
#define soFromEnd 2

#ifdef SOLFS_DOTNET
#typedef SolFSDateTime double
//#define __declspec(a)
#typedef CallbackDataType unsigned int
#else
#typedef CallbackDataType pointer // void*
#endif // SOLFS_DOTNET

#endif // SOLFS_WINDOWS

#ifdef SOLFS_UNIX
#typedef char Byte;
//#typedef Word unsigned word
#typedef char byte

#typedef LongLongWord u_int64_t
#typedef LongLongInt int64_t
#typedef Handle int
#typedef Error long

#typedef WideChar wchar_t
#typedef PWideChar pointer // WideChar *

#typedef TSeekOrigin int
#define soFromBegin SEEK_SET
#define soFromCurrent SEEK_CUR
#define soFromEnd SEEK_END

#typedef CallbackDataType pointer // void*

#endif // SOLFS_UNIX

#ifdef SOLFS_PALM
#typedef LongLongWord int64 // long long
#typedef LongLongInt int64 // long long
#typedef Error unsigned word

#typedef WideChar unsigned word
#typedef PWideChar pointer // unsigned word *

#typedef FileOriginEnum TSeekOrigin
#define soFromBegin fileOriginBeginning
#define soFromCurrent fileOriginCurrent
#define soFromEnd fileOriginEnd

#typedef CallbackDataType pointer // void*

#define MAX_PATH 31L
#define INVALID_FILE_HANDLE	0

#endif // SOLFS_PALM

#typedef PHandle pointer // Handle*

#ifdef SOLFS_DOTNET
#ifdef __BOOL_DEFINED
//typedef Bool int
#else
#typedef Bool unsigned byte
#endif
#else
//#typedef Bool byte
#endif //SOLFS_DOTNET

#typedef PByte pointer // char *
#typedef LongWord unsigned int
#typedef PChar pointer // char *
#typedef PWord pointer // unsigned word *
#typedef PLongWord pointer // unsigned int *
#typedef LongInt long

#ifndef SOLFS_NO_FPU
#typedef DateTime double
#else
#typedef Double LongLongWord
#typedef DateTime LongLongWord
#endif //

#define UnknownFileSize -1q//0xFFFFFFFFFFFFFFFFq

#define SolFSVersion 0x03000000

#ifdef SOLFS_DOTNET
#ifdef __BOOL_DEFINED
//#define True true
//#define False false
#else
//#define True -1
#define False 0
#endif
#else
//#define True -1
#define False 0
#endif //SOLFS_DOTNET

#define nil 0//NULL

#define errInvalidStorageFile -1
#define errInvalidPageSize -2
#define errStorageFileCorrupted -3
#define errTooManyTransactionsCommiting -4
#define errFileOrDirectoryAlreadyExists -5
#define errExistsActiveTransactions -6
#define errTagAlreadyExistInFile -7
#define errFileNotFound -8
#define errPathNotFound -9
#define errSharingViolation -10
#define errSeekBeyondEOF -11
#define errNoMoreFiles -12
#define errInvalidFileName -13
#define errStorageActive -14
#define errStorageNotActive -15
#define errInvalidPassword -16
#define errStorageReadOnly -17
#define errNoEncryptionHandlers -18
#define errOutOfMemory -19
#define errLinkDestinationNotFound -20
#define errFileIsNotSymLink -21
#define errBufferTooSmall -22
#define errBadCompressedData -23
#define errInvalidParameter -24
#define errStorageFull -25
#define errInterruptedByUser -26
#define errTagNotFound -27
#define errDirectoryNotEmpty -28
#define errHandleClosed -29
#define errInvalidStreamHandle -30
#define errFileAccessDenied -31
#define errNoCompressionHandlers -32
#define errNotImplemented -33
#define errLicenseKeyNotSet -34

#define errInternalError -200

//#ifdef SOLFS_PALM
//#define ERROR_OUTOFMEMORY	14L
//#endif

extern strStorageLogo as wstring; // WideChar

#define ecUnknown 0xFFFFFFFF
#define ecNoEncryption 0x0
#define ecAES256_SHA256 0x1
#define ecCustom 0x2
#define ecAES256_HMAC256 0x3

#define crUnknown 0xFFFFFFFF
#define crNoCompression 0x0
#define crDefault 0x1
#define crCustom 0x2
#define crZLib 0x3
#define crRLE 0x4

#define attrFile 0x00000001
#define attrDirectory 0x00000002
#define attrDataTree 0x00000004
#define attrCompressed 0x00000008
#define attrEncrypted 0x00000010
#define attrSymLink 0x00000020

#define attrReadOnly 0x00000040
#define attrArchive 0x00000080
#define attrHidden 0x00000100
#define attrSystem 0x00000200
#define attrTemporary 0x00000400
#define attrDeleteOnClose 0x00000800

#define attrReserved0 0x00001000
#define attrReserved1 0x00002000
#define attrReserved2 0x00004000
#define attrReserved3 0x00008000

#define attrReservedLo 0x00001000
#define attrReservedHi 0x00008000

#define attrAnyFile 0xFFFFFFFF

#define attrNoUserChange (attrFile | attrDirectory | attrDataTree | attrCompressed | attrEncrypted | attrSymLink | attrReserved0 | attrReserved1 | attrReserved2 | attrReserved3)
#define attrInheritable (attrCompressed)
#define attrUserDefined 0xFFFF0000

#define ftCreation 0x0001
#define ftModification 0x0002
#define ftLastAccess 0x0004
#define ftAllTimes 0x0007

#define ffNeedFullName 0x01
#define ffNeedFileTimes 0x02
#define ffNeedFileSize 0x04

#define ffEmulateFAT 0x8000

#define etCreated 0x0001
#define etDeleted 0x0002
#define etRenamed 0x0004
#define etAttributesChanged 0x0008
#define etDataSizeChanged 0x0010
#define etOtherChanged 0x8000

#define etAllEvents 0xFFFF

#define FileBlockSize 32

#define AES256_SHA256BlockSize 32
#define AES256_SHA256HashSize 32

#define AES256_HMAC256BlockSize 32
#define AES256_HMAC256HashSize 32

#define CustomBlockSize 32
#define CustomHashSize 32

#define ffFastFormat 0x0001
#define ffNoAllocFAT 0x0000
#define ffAllocFAT64K 0x0002
#define ffAllocFAT256K 0x0004
#define ffAllocFAT1M 0x0006
#define ffAllocFAT2M 0x0008
#define ffAllocFAT4M 0x000A
#define ffAllocFAT8M 0x000C
#define ffAllocFAT16M 0x000E
#define ffFormatFAT 0x0010
#define ffCreatePartition 0x0020

#define poFormatting 0
#define poChecking1 1
#define poChecking2 2
#define poChecking3 3
#define poChecking4 4
#define poChecking5 5
#define poReserved1 6
#define poReserved2 7
#define poPageCorrupted 8
#define poPageOrphaned 9
#define poCompressing 10
#define poDecompressing 11
#define poEncrypting 12
#define poDecrypting 13
#define poCompacting 14

#define tgFirstUserTag 0x8000
#define tgLastUserTag 0xCFFF

#define chrCheckOnly 0x0001
#define chrCheckAllPages 0x0002

#ifdef SOLFS_PALM
struct StorageSearchStruct {
	Handle SearchHandle;
	PWideChar FullName;
	PWideChar FileName;
	LongWord Attributes;
	DateTime Creation;
	DateTime Modification;
	DateTime LastAccess;
	LongWord FileSize;
}
#else
struct StorageSearchStruct {
	Handle SearchHandle;
	PWideChar FullName;
	PWideChar FileName;
	LongWord Attributes;
	DateTime Creation;
	DateTime Modification;
	DateTime LastAccess;
	LongLongWord FileSize;
}
#endif // SOLFS_PALM

struct StorageChangeStruct {
	LongWord EventType;
	DateTime ChangeDataTime;
	PWideChar Name;
	PWideChar NewName;
	LongWord Attributes;
	LongLongWord FileSize;
	Handle Internal;
}

struct StorageAccessGrantedProcessStruct {
	PWideChar ProcessFileName;
	LongWord ProcessID;
	Bool ChildProcesses;
}

#typedef PTreeCompareProc int//LongInt (_stdcall *PTreeCompareProc)(LongWord RecordSize1,Pointer RecordData1, LongWord RecordSize2, Pointer RecordData2);

#typedef SolFSIsCompactAllovedFunc int//Error (_stdcall *SolFSIsCompactAllovedFunc)(CallbackDataType UserData,Bool *IsCompactAlloved);

#typedef SolFSCreateFileFunc int//Error (_stdcall *SolFSCreateFileFunc)(CallbackDataType UserData,PWideChar FileName, PHandle File, Bool Overwrite, Bool IsJournalFile);
#typedef SolFSOpenFileFunc int//Error (_stdcall *SolFSOpenFileFunc)(CallbackDataType UserData,PWideChar FileName, PHandle File, Bool* ReadOnly, Bool IsJournalFile);
#typedef SolFSDeleteFileFunc int//Error (_stdcall *SolFSDeleteFileFunc)(CallbackDataType UserData,PWideChar FileName);
#typedef SolFSCloseFileFunc int//Error (_stdcall *SolFSCloseFileFunc)(CallbackDataType UserData,PHandle File);
#typedef SolFSFlushFileFunc int//Error (_stdcall *SolFSFlushFileFunc)(CallbackDataType UserData,Handle File);
#typedef SolFSGetFileSizeFunc int//Error (_stdcall *SolFSGetFileSizeFunc)(CallbackDataType UserData,Handle File, LongLongWord * Size);
#typedef SolFSSetFileSizeFunc int//Error (_stdcall *SolFSSetFileSizeFunc)(CallbackDataType UserData,Handle File, LongLongWord NewSize);
#typedef SolFSSeekFileFunc int//Error (_stdcall *SolFSSeekFileFunc)(CallbackDataType UserData,Handle File, LongLongInt Offset, TSeekOrigin Origin);
#typedef SolFSReadFileFunc int//Error (_stdcall *SolFSReadFileFunc)(CallbackDataType UserData,Handle File, Pointer Buffer, LongWord Count);
#typedef SolFSWriteFileFunc int//Error (_stdcall *SolFSWriteFileFunc)(CallbackDataType UserData,Handle File, Pointer Buffer, LongWord Count);

#typedef SolFSCalculateHashFunc int//Error (_stdcall *SolFSCalculateHashFunc)(CallbackDataType UserData,Pointer Buffer, LongWord Count, Pointer HashBuffer);
#typedef SolFSValidateHashFunc int//Error (_stdcall *SolFSValidateHashFunc)(CallbackDataType UserData,Pointer Buffer, LongWord Count, Pointer HashBuffer, Bool *Valid);
#typedef SolFSCryptDataFunc int//Error (_stdcall *SolFSCryptDataFunc)(CallbackDataType UserData,PChar Key, LongWord KeyLength, PChar Data, LongWord DataSize,LongWord ObjectID, LongWord PageIndex);

#typedef SolFSCompressDataFunc int//Error (_stdcall *SolFSCompressDataFunc)(CallbackDataType UserData,PChar InData, LongWord InDataSize, PChar OutData, LongWord *OutDataSize,LongWord CompressionLevel);
#typedef SolFSDecompressDataFunc int//Error (_stdcall *SolFSDecompressDataFunc)(CallbackDataType UserData,PChar InData, LongWord InDataSize, PChar OutData, LongWord *OutDataSize);

#typedef SolFSProgressFunc int//void (_stdcall *SolFSProgressFunc)(CallbackDataType UserData,LongWord Operation, LongWord Progress, LongWord Total,Bool CanStop, Bool *Stop);

#typedef SolFSChangeNotificationFunc int//void (_stdcall *SolFSChangeNotificationFunc)(CallbackDataType UserData,TStorageChange* Change, Handle ChangeNotification);


#ifndef SOLFS_NATIVE_LINK
	#define nSOLFS_NATIVE_LINK_or_SOLFS_NT_DRV_API
#endif
#ifdef SOLFS_NT_DRV_API
	#define nSOLFS_NATIVE_LINK_or_SOLFS_NT_DRV_API
#endif

#ifdef nSOLFS_NATIVE_LINK_or_SOLFS_NT_DRV_API
declare import, StorageInit(),Error;
declare import, StorageDone(),Error;

declare import, StorageSetRegistrationKey(PChar Key),Error;

declare import, StorageGetVersion(LongWord *Version),Error;

declare import, StorageCheckAndRepair(PWideChar FileName,
	LongWord PageSize, LongWord Flags, PWideChar Password, LongWord PasswordLen,
	CallbackDataType ProgressUserData, SolFSProgressFunc ProgressFunc),Error;

declare import, StorageCheckAndRepairCB(PWideChar FileName,
	LongWord PageSize, LongWord Flags, PWideChar Password, LongWord PasswordLen,
	CallbackDataType ProgressUserData, SolFSProgressFunc ProgressFunc,
	// callbacks
	CallbackDataType UserData,
	SolFSCreateFileFunc CreateFileFunc, SolFSOpenFileFunc OpenFileFunc,
	SolFSCloseFileFunc CloseFileFunc, SolFSFlushFileFunc FlushFileFunc,
	SolFSDeleteFileFunc DeleteFileFunc, SolFSGetFileSizeFunc GetFileSizeFunc,
	SolFSSetFileSizeFunc SetFileSizeFunc, SolFSSeekFileFunc SeekFileFunc,
	SolFSReadFileFunc ReadFileFunc, SolFSWriteFileFunc WriteFileFunc),Error;

declare import, StorageCheckAndRepairCB2(PWideChar FileName,
	LongWord PageSize, LongWord Flags, PWideChar Password, LongWord PasswordLen,
	CallbackDataType ProgressUserData, SolFSProgressFunc ProgressFunc,
	// callbacks
	Bool UseCallbacks, CallbackDataType UserData,
	SolFSCreateFileFunc CreateFileFunc, SolFSOpenFileFunc OpenFileFunc,
	SolFSCloseFileFunc CloseFileFunc, SolFSFlushFileFunc FlushFileFunc,
	SolFSDeleteFileFunc DeleteFileFunc, SolFSGetFileSizeFunc GetFileSizeFunc,
	SolFSSetFileSizeFunc SetFileSizeFunc, SolFSSeekFileFunc SeekFileFunc,
	SolFSReadFileFunc ReadFileFunc, SolFSWriteFileFunc WriteFileFunc,

	CallbackDataType CryptUserData,
	SolFSCalculateHashFunc CalculateHashFunc,
	SolFSValidateHashFunc ValidateHashFunc,
	SolFSCryptDataFunc EncryptDataFunc,
	SolFSCryptDataFunc DecryptDataFunc,

	CallbackDataType CompressUserData,
	SolFSCompressDataFunc CompressDataFunc,
	SolFSDecompressDataFunc DecompressDataFunc),Error;

declare import, StorageFormatFixedSize(
	PWideChar FileName, LongLongWord FileSize, LongWord PageSize,
	PWideChar Logo, LongWord Flags, CallbackDataType ProgressUserData,
	SolFSProgressFunc ProgressFunc),Error;
declare import, StorageFormatFixedSizeCB(
	PWideChar FileName, LongLongWord FileSize, LongWord PageSize,
	PWideChar Logo, LongWord Flags, CallbackDataType ProgressUserData,
	SolFSProgressFunc ProgressFunc,
	// callbacks
	CallbackDataType UserData,
	SolFSCreateFileFunc CreateFileFunc, SolFSOpenFileFunc OpenFileFunc,
	SolFSCloseFileFunc CloseFileFunc, SolFSFlushFileFunc FlushFileFunc,
	SolFSDeleteFileFunc DeleteFileFunc, SolFSGetFileSizeFunc GetFileSizeFunc,
	SolFSSetFileSizeFunc SetFileSizeFunc, SolFSSeekFileFunc SeekFileFunc,
	SolFSReadFileFunc ReadFileFunc, SolFSWriteFileFunc WriteFileFunc),Error;

declare import, StorageIsValidStorage(PWideChar FileName),Error;

declare import, StorageIsValidStorageEx(PWideChar FileName,
	Bool *Corrupted, LongWord *StorageID, LongWord *PageSize,
	PWideChar LogoBuffer, LongWord LogoBufferSize),Error;

declare import, StorageIsValidStorageCB(PWideChar FileName,
	// callbacks
	CallbackDataType UserData,
	SolFSCreateFileFunc CreateFileFunc, SolFSOpenFileFunc OpenFileFunc,
	SolFSCloseFileFunc CloseFileFunc, SolFSFlushFileFunc FlushFileFunc,
	SolFSDeleteFileFunc DeleteFileFunc, SolFSGetFileSizeFunc GetFileSizeFunc,
	SolFSSetFileSizeFunc SetFileSizeFunc, SolFSSeekFileFunc SeekFileFunc,
	SolFSReadFileFunc ReadFileFunc, SolFSWriteFileFunc WriteFileFunc),Error;

declare import, StorageIsValidStorageExCB(PWideChar FileName,
	Bool *Corrupted, LongWord *StorageID, LongWord *PageSize,
	PWideChar LogoBuffer, LongWord LogoBufferSize,
	// callbacks
	CallbackDataType UserData,
	SolFSCreateFileFunc CreateFileFunc, SolFSOpenFileFunc OpenFileFunc,
	SolFSCloseFileFunc CloseFileFunc, SolFSFlushFileFunc FlushFileFunc,
	SolFSDeleteFileFunc DeleteFileFunc, SolFSGetFileSizeFunc GetFileSizeFunc,
	SolFSSetFileSizeFunc SetFileSizeFunc, SolFSSeekFileFunc SeekFileFunc,
	SolFSReadFileFunc ReadFileFunc, SolFSWriteFileFunc WriteFileFunc),Error;

declare import, StorageCreate(PWideChar FileName,
	Bool Overwrite, LongWord PageSize, PWideChar Logo, PHandle Storage,
	WideChar PathSeparator, Bool UseTransactions, Bool UseAccessTime),Error;

declare import, StorageCreateCB(
	PWideChar FileName, Bool Overwrite, LongWord PageSize, PWideChar Logo,
	PHandle Storage, WideChar PathSeparator, Bool UseTransactions,
	Bool UseAccessTime, Bool ReadOnly,
	// callbacks
	CallbackDataType UserData,
	SolFSCreateFileFunc CreateFileFunc, SolFSOpenFileFunc OpenFileFunc,
	SolFSCloseFileFunc CloseFileFunc, SolFSFlushFileFunc FlushFileFunc,
	SolFSDeleteFileFunc DeleteFileFunc, SolFSGetFileSizeFunc GetFileSizeFunc,
	SolFSSetFileSizeFunc SetFileSizeFunc, SolFSSeekFileFunc SeekFileFunc,
	SolFSReadFileFunc ReadFileFunc, SolFSWriteFileFunc WriteFileFunc),Error;

declare import, StorageOpen(
	PWideChar FileName, PHandle Storage, WideChar PathSeparator,
	Bool UseTransactions, Bool UseAccessTime),Error;

declare import, StorageOpenReadOnly(
	PWideChar FileName, PHandle Storage, WideChar PathSeparator,
	Bool UseTransactions, Bool UseAccessTime),Error;

declare import, StorageOpenCB(
	PWideChar FileName, PHandle Storage, WideChar PathSeparator,
	Bool UseTransactions, Bool UseAccessTime, Bool ReadOnly,
	// callbacks
	CallbackDataType UserData,
	SolFSCreateFileFunc CreateFileFunc, SolFSOpenFileFunc OpenFileFunc,
	SolFSCloseFileFunc CloseFileFunc, SolFSFlushFileFunc FlushFileFunc,
	SolFSDeleteFileFunc DeleteFileFunc, SolFSGetFileSizeFunc GetFileSizeFunc,
	SolFSSetFileSizeFunc SetFileSizeFunc, SolFSSeekFileFunc SeekFileFunc,
	SolFSReadFileFunc ReadFileFunc, SolFSWriteFileFunc WriteFileFunc),Error;

declare import, StorageSetRegistrationKeyEx(
	Handle Storage, PChar Key),Error;

// Functions specific to Driver Edition

declare import, StorageInstallDrivers(
	PWideChar VirtualDiskDriverFileName, PWideChar FileSystemDriverFileName,
	Bool *RebootNeeded),Error;
declare import, StorageUninstallDrivers(Bool *RebootNeeded),Error;

declare import, StorageForceUnmount(PWideChar FileName),Error;

declare import, StorageGetMountingPointCount(
	Handle Storage, LongWord *MountingPointCount),Error;
declare import, StorageGetMountingPoint(
	Handle Storage, LongWord Index, PWideChar MountingPointBuffer,
	LongWord *MountingPointBufferSize),Error;
declare import, StorageAddMountingPoint(
	Handle Storage, PWideChar MountingPoint),Error;
declare import, StorageDeleteMountingPoint(
	Handle Storage, PWideChar MountingPoint),Error;

declare import, StorageConvertFileNameToSystem(
	Handle Storage, PWideChar StorageFileName, PWideChar SystemFileNameBuffer,
	LongWord *SystemFileNameBufferSize),Error;
declare import, StorageConvertFileNameToStorage(
	Handle Storage, PWideChar SystemFileName, PWideChar StorageFileNameBuffer,
	LongWord *StorageFileNameBufferSize),Error;

declare import, StorageSetProcessRestrictions(
	Handle Storage, Bool RestrictionsEnabled),Error;
declare import, StorageGetProcessRestrictions(
	Handle Storage, Bool *RestrictionsEnabled),Error;

declare import, StorageGetAccessGrantedProcessCount(
	Handle Storage, LongWord *AccessGrantedProcessCount),Error;
declare import, StorageGetAccessGrantedProcess(
	Handle Storage, LongWord Index, TStorageAccessGrantedProcess* Process),Error;
declare import, StorageClearAccessGrantedProcessStruct(
	TStorageAccessGrantedProcess* Process),Error;
declare import, StorageAddAccessGrantedProcess(
	Handle Storage, TStorageAccessGrantedProcess* Process),Error;
declare import, StorageDeleteAccessGrantedProcess(
	Handle Storage, TStorageAccessGrantedProcess* Process),Error;

// End of functions specific to Driver Edition

declare import, StorageSetCustomEncryptionHandlers(
	Handle Storage,
	// callbacks
	CallbackDataType UserData,
	SolFSCalculateHashFunc CalculateHashFunc,
	SolFSValidateHashFunc ValidateHashFunc,
	SolFSCryptDataFunc EncryptDataFunc,
	SolFSCryptDataFunc DecryptDataFunc),Error;

declare import, StorageSetCustomCompressionHandlers(
	Handle Storage,
	// callbacks
	CallbackDataType UserData,
	SolFSCompressDataFunc CompressDataFunc,
	SolFSDecompressDataFunc DecompressDataFunc),Error;

declare import, StorageClose(Handle Storage),Error;
declare import, StorageSetTrialExpired(),Error;

declare import, StorageOpenRootData(Handle Storage, PHandle File),Error;

declare import, StorageGetEncryption(Handle Storage,
	LongWord *Encryption),Error;
declare import, StorageCheckPassword(Handle Storage,
	PWideChar Password, LongWord PasswordLen, Bool *Valid,
	LongWord *ActualEncryption),Error;
declare import, StorageSetPassword(Handle Storage,
	PWideChar Password, LongWord PasswordLen),Error;
declare import, StorageSetEncryption(Handle Storage,
	LongWord Encryption, PWideChar OldPassword, LongWord OldPasswordLen,
	PWideChar NewPassword, LongWord NewPasswordLen),Error;
declare import, StorageSetEncryptionEx(Handle Storage,
	LongWord Encryption, PWideChar OldPassword, LongWord OldPasswordLen,
	PWideChar NewPassword, LongWord NewPasswordLen, CallbackDataType UserData,
	SolFSProgressFunc ProgressFunc),Error;

//$ifndef SOLFS_NO_CUSTOM
//$ifdef SOLFS_CUSTOM_ALFEGA
//$ifdef 0
#ifdef SOLFS_CUSTOM_ALFEGA
//$endif
declare import, StorageAddPasswordRecovery(Handle Storage,
	PWideChar Password, LongWord PasswordLen,
	PWideChar Question, LongWord QuestionLen,
	PWideChar Answer, LongWord AnswerLen),Error;
declare import, StorageGetPasswordRecovery(Handle Storage,
	PWideChar Question, LongWord *QuestionLen),Error;
DLLEXPORTSPEC Error CALLCONVSPEC StorageDeletePasswordRecovery(Handle Storage),;
declare import, StorageRecoverPassword(Handle Storage,
	PWideChar Answer, LongWord AnswerLen,
	PWideChar Password, LongWord *PasswordLen),Error;
//$ifdef 0
#endif
//$endif
//$endif
//$endif

declare import, StorageIsCorrupted(Handle Storage,
	Bool *Corrupted),Error;
declare import, StorageGetStorageID(Handle Storage,
	LongWord *StorageID),Error;

declare import, StorageIsMediaChanged(Handle Storage,
	Bool *Changed),Error;

declare import, StorageIsReadOnly(Handle Storage,
	Bool *ReadOnly),Error;
declare import, StorageIsFixedSize(Handle Storage,
	Bool *FixedSize),Error;
declare import, StorageGetInfo(Handle Storage,
	LongWord *PageSize, PWideChar *Logo),Error;
declare import, StorageGetSizes(Handle Storage,
	Bool *FixedSize, LongLongWord *TotalSize, LongLongWord *FreeSpace),Error;

declare import, StorageGetMaxPageCount(Handle Storage,
	LongWord *PageCount),Error;
declare import, StorageSetMaxPageCount(Handle Storage,
	LongWord PageCount),Error;

declare import, StorageSetLogo(Handle Storage,
	PWideChar Logo),Error;

declare import, StorageGetCaseSensitive(Handle Storage,
	Bool *Value),Error;
declare import, StorageSetCaseSensitive(Handle Storage,
	Bool Value),Error;
declare import, StorageGetSeparator(Handle Storage,
	WideChar *Value),Error;
declare import, StorageSetSeparator(Handle Storage,
	WideChar Value),Error;
declare import, StorageGetUseTransactions(Handle Storage,
	Bool *Value),Error;
declare import, StorageSetUseTransactions(Handle Storage,
	Bool Value),Error;
declare import, StorageGetUseAccessTime(Handle Storage,
	Bool *Value),Error;
declare import, StorageSetUseAccessTime(Handle Storage,
	Bool Value),Error;
declare import, StorageGetLastAccessTime(Handle Storage,
	DateTime *Time),Error;
declare import, StorageGetLastWriteTime(Handle Storage,
	DateTime *Time),Error;

declare import, StorageGetAutoCompact(Handle Storage,
	LongWord *Percent),Error;
declare import, StorageSetAutoCompact(Handle Storage,
	LongWord Percent),Error;
#ifndef SOLFS_NO_CB
declare /*cdecl ??*/ import, StorageSetAutoCompactEx(Handle Storage, LongWord Percent,
	CallbackDataType UserData, SolFSIsCompactAllovedFunc IsCompactAllovedFunc),Error;
#endif // SOLFS_NO_CB

/*
declare import, StorageGetDefaultCompression(
	Handle Storage, LongWord *Compression, LongWord *CompressionLevel,
	LongWord *PagesPerCluster, Bool *UseForNewFiles),Error;
declare import, StorageSetDefaultCompression(
	Handle Storage, LongWord Compression, LongWord CompressionLevel,
	LongWord PagesPerCluster, Bool UseForNewFiles),Error;
*/

declare import, StorageGetBuffering(Handle Storage,
	LongWord *PagesPerCluster),Error;
declare import, StorageSetBuffering(Handle Storage,
	LongWord PagesPerCluster),Error;

declare import, StorageCompact(Handle Storage,
	Bool *Compacted),Error;
declare import, StorageOnIdle(Handle Storage),Error;

declare import, StorageFileExists(Handle Storage,
	PWideChar FileName, Bool *Exists),Error;
declare import, StorageCreateDirectory(Handle Storage,
	PWideChar Directory),Error;
declare import, StorageForceCreateDirectories(Handle Storage,
	PWideChar Path),Error;
declare import, StorageDeleteDirectory(Handle Storage,
	PWideChar Directory),Error;
declare import, StorageIsDirectoryEmpty(Handle Storage,
	PWideChar Directory, Bool *Empty),Error;

declare import, StorageGetFileEncryption(Handle Storage,
	PWideChar FileName, LongWord *Encryption),Error;
declare import, StorageSetFileEncryption(Handle Storage,
	PWideChar FileName, LongWord Encryption,
	PWideChar OldPassword, LongWord OldPasswordLen,
	PWideChar NewPassword, LongWord NewPasswordLen),Error;
declare import, StorageCheckFilePassword(Handle Storage,
	PWideChar FileName, LongWord Encryption, Bool EncryptionUnknown,
	PWideChar Password, LongWord PasswordLen, Bool *Valid),Error;

declare import, StorageGetFileCompression(Handle Storage,
	PWideChar FileName, LongWord *Compression, LongWord *CompressionLevel,
	LongWord *PagesPerCluster),Error;
declare import, StorageSetFileCompression(Handle Storage,
	PWideChar FileName, LongWord Compression, LongWord CompressionLevel,
	LongWord PagesPerCluster, PWideChar Password, LongWord PasswordLen),Error;

declare import, StorageGetFileAttributes(Handle Storage,
	PWideChar FileName, LongWord *Attributes),Error;
declare import, StorageSetFileAttributes(Handle Storage,
	PWideChar FileName, LongWord Attributes),Error;

declare import, StorageLink(Handle Storage,
	PWideChar LinkName, PWideChar DestinationName),Error;
declare import, StorageGetLinkDestination(Handle Storage,
	PWideChar LinkName, PWideChar *DestinationName),Error;
declare import, StorageGetLinkDestinationEx(Handle Storage,
	PWideChar LinkName, PWideChar DestinationBuffer,
	LongWord *DestinationBufferSize),Error;
declare import, StorageResolveLink(Handle Storage,
	PWideChar LinkName, PWideChar DestinationBuffer,
	LongWord *DestinationBufferSize),Error;

declare import, StorageGetFileCreationTime(Handle Storage,
	PWideChar FileName, DateTime *Time),Error;
declare import, StorageSetFileCreationTime(Handle Storage,
	PWideChar FileName, DateTime NewTime),Error;
declare import, StorageGetFileModificationTime(Handle Storage,
	PWideChar FileName, DateTime *Time),Error;
declare import, StorageSetFileModificationTime(Handle Storage,
	PWideChar FileName, DateTime NewTime),Error;
declare import, StorageGetFileLastAccessTime(Handle Storage,
	PWideChar FileName, DateTime *Time),Error;
declare import, StorageSetFileLastAccessTime(Handle Storage,
	PWideChar FileName, DateTime NewTime),Error;

declare import, StorageGetFileTimes(Handle Storage,
	PWideChar FileName, DateTime *Creation, DateTime *Modification,
	DateTime *LastAccess),Error;
declare import, StorageSetFileTimes(Handle Storage,
	PWideChar FileName, DateTime Creation, DateTime Modification,
	DateTime LastAccess),Error;

declare import, StorageGetFileTagInfo(Handle Storage,
	PWideChar FileName, unsigned word TagID, Bool *TagExists, LongWord *TagDataSize),Error;
declare import, StorageGetFileTag(Handle Storage,
	PWideChar FileName, unsigned word TagID, Pointer TagData, LongWord *TagDataSize),Error;
declare import, StorageSetFileTag(Handle Storage,
	PWideChar FileName, unsigned word TagID, Pointer TagData, LongWord TagDataSize),Error;
declare import, StorageDeleteFileTag(Handle Storage,
	PWideChar FileName, unsigned word TagID),Error;

declare import, StorageFindFirst(Handle Storage,
	TStorageSearch* Search, PWideChar Mask, LongWord Attributes),Error;
declare import, StorageFindFirstEx(Handle Storage,
	TStorageSearch* Search, PWideChar Mask, LongWord Attributes, LongWord Flags),Error;
declare import, StorageFindNext(Handle Storage,
	TStorageSearch* Search),Error;
declare import, StorageFindClose(Handle Storage,
	TStorageSearch* Search),Error;

declare import, StorageAddChangeNotification(Handle Storage,
	PWideChar Path, Bool Recursive, LongWord EventMask,
	CallbackDataType CallbackUserData,
	SolFSChangeNotificationFunc NotificationFunc, PHandle ChangeNotification),Error;
declare import, StorageRemoveChangeNotification(Handle Storage,
	Handle ChangeNotification),Error;

declare import, StorageSetFilePassword(Handle Storage,
	PWideChar FileName, PWideChar Password, LongWord PasswordLen),Error;

declare import, StorageCreateFile(Handle Storage,
	PWideChar FileName, Bool ReadEnabled, Bool WriteEnabled,
	Bool ShareDenyRead, Bool ShareDenyWrite,
	LongWord Encryption, PWideChar Password, LongWord PasswordLen, PHandle File,
	Bool OpenExisting, Bool TruncateExisting),Error;
declare import, StorageCreateFileCompressed(Handle Storage,
	PWideChar FileName, Bool ReadEnabled, Bool WriteEnabled,
	Bool ShareDenyRead, Bool ShareDenyWrite,
	LongWord Encryption, PWideChar Password, LongWord PasswordLen,
	LongWord Compression, LongWord CompressionLevel, LongWord PagesPerCluster,
	PHandle File, Bool OpenExisting, Bool TruncateExisting),Error;
declare import, StorageOpenFile(Handle Storage,
	PWideChar FileName, Bool ReadEnabled, Bool WriteEnabled,
	Bool ShareDenyRead, Bool ShareDenyWrite,
	PWideChar Password, LongWord PasswordLen, PHandle File),Error;
declare import, StorageCloseFile(Handle File),Error;
declare import, StorageFlushFile(Handle File),Error;
declare import, StorageFlushFileEx(Handle File,
	LongWord Flags),Error;

declare import, StorageDeleteFile(Handle Storage,
	PWideChar FileName),Error;

declare import, StorageMoveFile(Handle Storage,
	PWideChar OldFileName, PWideChar NewFileName),Error;
declare import, StorageDeleteAndRenameFile(Handle Storage,
	PWideChar OldFileName, PWideChar NewFileName),Error;

declare import, StorageGetFileSize(Handle File,
	LongWord *FileSize),Error;
declare import, StorageGetFileSizeLong(Handle File,
	LongLongWord *FileSize),Error;
declare import, StorageGetFileDataSizeLong(Handle File,
	LongLongWord *FileDataSize),Error;
declare import, StorageSetFileDataSizeLong(Handle File,
	LongLongWord FileDataSize),Error;
declare import, StorageSetFileEndLong(Handle File,
	LongLongWord FileSize),Error;

declare import, StorageSetFileSize(Handle File,
	LongWord FileSize),Error;
declare import, StorageSetFileSizeLong(Handle File,
	LongLongWord FileSize),Error;
declare import, StorageSetEndOfFile(Handle File),Error;

declare import, StorageSeekFile(Handle File,
	LongInt Offset, TSeekOrigin Origin, LongWord *Position),Error;
declare import, StorageSeekFileLong(Handle File,
	LongLongInt Offset, TSeekOrigin Origin, LongLongWord *Position),Error;
declare import, StorageTellFile(Handle File,
	LongWord *Position),Error;
declare import, StorageTellFileLong(Handle File,
	LongLongWord *Position),Error;
declare import, StorageReadFile(Handle File,
	Pointer Buffer, LongInt BufferSize, LongWord *Read),Error;
declare import, StorageWriteFile(Handle File,
	Pointer Buffer, LongInt BufferSize, LongWord *Written),Error;

declare import, StorageReadFileWithSeek(Handle File,
	LongLongInt FileOffset, Pointer Buffer, LongInt BufferSize,
	LongWord *Read),Error;
declare import, StorageWriteFileWithSeek(Handle File,
	LongLongInt FileOffset, Pointer Buffer, LongInt BufferSize,
	LongWord *Written),Error;

/*#if (defined(SOLFS_WINDOWS) && defined(SOLFS_DEBUG) && !defined(SOLFS_WINCE))
declare import, StorageGetMemUsage(
	LongWord *ppMemoryAllocated, LongWord *ppMemoryAllocatedCount,
	LongWord *ppMaxMemoryAllocated, LongWord *ppMaxMemoryAllocatedCount),Error;
#endif*/


#endif 

#endif //!defined(STORE_DECL_H)